library amzip;

uses Windows, unzipfile, zlibpas;

{$E .spi}
{$R *.RES}

const
  Version = '0.4 (zlib '+ZLIB_VERSION+')';
  PluginInfo: array[0..3] of PChar = (
    '00AM',
    'ZIP extract library ver'+Version+' (C)Ferdia',
    '*.zip',
    'ZIP file(*.zip)'
  );

const
  SPI_ERROR_NOT_IMPLEMENTED = (-1); // ̋@\͖
  SPI_ERROR_SUCCESS         = 0;    // I
  SPI_ERROR_CANCEL_EXPAND   = 1;    // R[obN֐0Ԃ
  SPI_ERROR_UNKNOWN_FORMAT  = 2;    // m̃tH[}bg
  SPI_ERROR_BROKEN_DATA     = 3;    // f[^Ă
  SPI_ERROR_ALLOCATE_MEMORY = 4;    // [mۏoȂ
  SPI_ERROR_MEMORY          = 5;    // [G[iLockoȂj
  SPI_ERROR_FILE_READ       = 6;    // t@C[hG[
  SPI_ERROR_WINDOW          = 7;    // JȂ (J)
  SPI_ERROR_INTERNAL        = 8;    // G[
  SPI_ERROR_FILE_WRITE      = 9;    // ݃G[ (J)
  SPI_ERROR_END_OF_FILE     = 10;   // t@CI[ (J)

type
  unsigned_long = Cardinal;
  unsigned_int = Cardinal;
  time_t = Longint;

  // TFileInfo
  PFileInfo = ^TFileInfo;
  TFileInfo = packed record
    method:    array[0..7] of Char;
    position:  unsigned_long;
    compsize:  unsigned_long;
    filesize:  unsigned_long;
    timestamp: time_t;
    path:      array[0..199] of Char;
    filename:  array[0..199] of Char;
    crc:       unsigned_long;
  end;

  TProgressCallback = function (nNum, nDemon: Integer; lData: Longint):
    Integer; stdcall;

function DosTimeTotime_t(DosDate, DosTime: Word): Integer;
var
  lft, ft: TFileTime;
begin
  DosDateTimeToFileTime(DOSDate, DOSTime, lft);
  LocalFileTimetoFileTime(lft, ft);
  // Trunc((1970-1601)*365.2425)*24*60*60 = 11644473600
  Result := Trunc(Comp(ft) / 10000000.0 - 11644473600.0);
end;

// ΃pX\LPathfBNgƃt@Cɕ
// pX؂'/''\'ɕϊ('\'łȂsusie摜WJłȂ)
procedure SplitPath(Path: string; var Head, Tail: string);
var
  i, dpos: Integer;
begin
  dpos := 0;
  i := 0;
  while i < Length(Path) do
  begin
    Inc(i);
    if IsDBCSLeadByte(Byte(Path[i])) then
      Inc(i)
    else if Path[i] in ['\', '/'] then
    begin
      Path[i] := '\';
      dpos := i;
    end;
  end;
  Head := Copy(Path, 1, dpos); // \͂Ă
  Tail := Copy(Path, dpos+1, Length(Path)-dpos);
end;


{ Plugin Functions }

function GetPluginInfo(infono: Integer; buf: PChar; buflen: Integer): Integer; stdcall;
begin
  if (infono < 0) or (infono > High(PluginInfo)) then
    Result := 0
  else begin
    lstrcpyn(buf, PluginInfo[infono], buflen);
    Result := lstrlen(buf);
  end;
end;

function IsSupported(filename: LPSTR; dw: DWORD): Integer; stdcall;
var
  sign: TSign;
  readbytes: DWORD;
begin
  if (dw and $FFFF0000) = 0 then
  begin
    if not ReadFile(dw, sign, SizeOf(sign), readbytes, nil) then
    begin
      Result := 0;
      Exit;
    end;
  end else
    sign := PSign(dw)^;

  if sign = ZIP_FILE_HEADER_SIGN then
    Result := 1
  else
    Result := 0
end;

// t@CT̂len͖
function GetArchiveInfo(buf: LPSTR; len: Longint; flag: unsigned_int;
  var hinf: HLOCAL): Integer; stdcall;
var
  hfile : THandle;
  ecdir: TEndOfCentralDirectory;
  ofs: Integer;
  filecount : Integer;
  cdir: TCentralDirectory;
  htmp: HLOCAL;
  fname, head, tail: string;
  info : PFileInfo;
begin
  if (flag and 7) <> 0 then //͖Ή
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;

  hfile := CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if hfile = INVALID_HANDLE_VALUE then
  begin
    Result := SPI_ERROR_FILE_READ;
    Exit;
  end;

  try
    if not ReadEndOfCentralDir(hfile, ecdir, ofs) then
    begin
      Result := SPI_ERROR_BROKEN_DATA;
      Exit;
    end;

    hinf := LocalAlloc(LHND, SizeOf(TFileInfo));
    if hinf = 0 then
    begin
      Result := SPI_ERROR_ALLOCATE_MEMORY;
      Exit;
    end;

    filecount := 0;
    while ReadCentralDir(hfile, cdir, fname) do
    begin
      Inc(filecount);
      htmp := LocalRealloc(hinf, SizeOf(TFileInfo)*(filecount+1),
        LMEM_MOVEABLE or LMEM_ZEROINIT);
      if htmp = 0 then
      begin
        LocalFree(hinf);
        Result := SPI_ERROR_ALLOCATE_MEMORY;
        Exit;
      end else
        hinf := htmp;

      info := LocalLock(hinf);
      Inc(info, FileCount-1);
      case cdir.Method of
        0: info.method := 'Stored';
        Z_DEFLATED: info.method := 'Deflate';
      else
        info.method := 'unknown';
      end;
      info.position := cdir.LocalHeaderOffset + ofs;
      info.compsize := cdir.CompSize;
      info.filesize := cdir.UnCompSize;
      info.timestamp := DosTimeTotime_t(cdir.FileMDate, cdir.FileMTime);
      info.CRC := cdir.Crc;
      SplitPath(fname, head, tail);
      lstrcpyn(info.path, PChar(head), SizeOf(info.path));
      lstrcpyn(info.filename, PChar(tail), SizeOf(info.filename));
      LocalUnLock(hinf);
    end;
    Result := SPI_ERROR_SUCCESS;
  finally
    CloseHandle(hfile);
  end;
end;

function GetFileInfo(buf: LPSTR; len: Longint; filename: LPSTR; flag: unsigned_int;
  var Info: TFileInfo): Integer; stdcall;
var
  hfile : THandle;
  header: TZipFileHeader;
  fname, head, tail: string;
begin
  if (flag and 7) <> 0 then //͖Ή
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;

  hfile := CreateFile(buf, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if hfile = INVALID_HANDLE_VALUE then
  begin
    Result := SPI_ERROR_FILE_READ;
    Exit;
  end;
  
  try
    SetFilePointer(hfile, len, nil, FILE_BEGIN); // ItZbgV[N

    if not ReadZipFileHeader(hfile, header, fname) then
    begin
      Result := SPI_ERROR_BROKEN_DATA;
      Exit;
    end;

    case header.Method of
      0: Info.method := 'Stored';
      Z_DEFLATED: Info.method := 'Deflate';
    end;
    Info.position := len;
    Info.compsize := header.CompSize;
    Info.filesize := header.UnCompSize;
    Info.timestamp := DosTimeTotime_t(header.FileMDate, header.FileMTime);
    Info.CRC := header.Crc;
    SplitPath(fname, head, tail);
    lstrcpyn(Info.path, PChar(head), SizeOf(Info.path));
    lstrcpyn(Info.filename, PChar(tail), SizeOf(Info.filename));

    Result := SPI_ERROR_SUCCESS;
  finally
    CloseHandle(hfile);
  end;
end;

function GetFile(src: LPSTR; len: Longint; dest: LPSTR; flag: unsigned_int;
  ProgressCallback: TProgressCallback; lData: Longint): Integer; stdcall;
var
  hfile : THandle;
  header: TZipFileHeader;
  phmem : PHandle;
  fname: string;
begin
  //t@Co, ͖Ή
  if ((flag and $700) = 0) or ((flag and 7) <> 0) then
  begin
    Result := SPI_ERROR_NOT_IMPLEMENTED;
    Exit;
  end;

  if Assigned(ProgressCallBack) then
  begin
    if ProgressCallBack(0, 100, lData) <> 0 then
    begin
      Result := SPI_ERROR_CANCEL_EXPAND;
      Exit;
    end;
  end;

  hfile := CreateFile(src, GENERIC_READ, FILE_SHARE_READ, nil, OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL, 0);
  if hfile = INVALID_HANDLE_VALUE then
  begin
    Result := SPI_ERROR_FILE_READ;
    Exit;
  end;

  try
    SetFilePointer(hfile, len, nil, FILE_BEGIN); // ItZbgV[N

    if not ReadZipFileHeader(hfile, header, fname) then
    begin
      Result := SPI_ERROR_BROKEN_DATA;
      Exit;
    end;

    phmem := PHandle(dest);
    phmem^ := LocalAlloc(LMEM_MOVEABLE, header.UnCompSize);
    if phmem^ = HLOCAL(nil) then
    begin
      Result := SPI_ERROR_ALLOCATE_MEMORY;
      Exit;
    end;

    try
      case Extract(hfile, header, LocalLock(phmem^), header.UnCompSize) of
        UNZIP_OK: Result := SPI_ERROR_SUCCESS;
        UNZIP_MEMERR: Result := SPI_ERROR_ALLOCATE_MEMORY;
        UNZIP_BROKEN: Result := SPI_ERROR_BROKEN_DATA;
      else
        Result := SPI_ERROR_SUCCESS; // NOTREACHED */
      end;
    finally
      LocalUnLock(phmem^);
    end;
  finally
    CloseHandle(hfile);
  end;

  if Assigned(ProgressCallBack) then
  begin
    if ProgressCallBack(100, 100, lData) <> 0 then
    begin
      Result := SPI_ERROR_CANCEL_EXPAND;
      Exit;
    end;
  end;
end;

{
// Plug-inݒ_CAO\
function ConfigurationDlg(Parent: HWND; fnc: Integer): Integer; stdcall;
begin
  Result := SPI_ERROR_NOT_IMPLEMENTED;
end;
}

exports
  //ConfigurationDlg,
  GetPluginInfo,
  IsSupported,
  GetArchiveInfo,
  GetFileInfo,
  GetFile;

begin
  IsMultiThread := True;
end.

